#
# Dungeon game main program.
# Reads in the dungeon configuration from standard input.
# Usage:
#  python DungeonGame.py d0.txt
#  
# ##### DO NOT MODIFY THIS FILE #### 
#  
# Author Keith Vertanen
# Author Michele Van Dyne - file input modifications
#                         - 11/12/19 - ported to python
# Author Michele Van Dyne - file input modifications
#                         - 12/3/19 - ported to python
#

from Config import Config
from Dungeon import Dungeon
from Hero import Hero
from Item import Item
import sys
import StdDraw
from DungeonFactory import DungeonFactory
import sys

#
# Program for the game control and game loop
# 
# param: args file name for the configuration file
#             files provided are d0.txt, d1.txt, d2.txt
#

config = Config()
dungeon = DungeonFactory.createFromFile(config, sys.argv[1])
width = dungeon.getWidth()
height = dungeon.getHeight()
StdDraw.setCanvasSize(config.cellPixels() * width, config.cellPixels() * height)
StdDraw.setXscale(0.0, config.cellPixels() * width)
StdDraw.setYscale(0.0, config.cellPixels() * height)

dungeon.draw()
gameOn = True

while gameOn:
    if StdDraw.hasNextKeyTyped():
        action = config.mapKeyToAction(StdDraw.nextKeyTyped())
        gameOn = dungeon.execute(action)
        dungeon.draw()
        if dungeon.getCount(Item.GEM) == 0:
            gameOn = False
    StdDraw.show(100)
